#cooldown
scoreboard objectives add chainCD dummy
scoreboard players add @a chainCD 0
scoreboard players remove @a[scores={chainCD=1..},tag=!freeze] chainCD 1

#weakness
effect @a[tag=chainsaw,tag=hasForm] weakness 1 255 true

#chainsaw movement and sounds
scoreboard objectives add chainTexture dummy
scoreboard players add @a[tag=chainsaw,tag=hasForm,tag=!chainsawOff,tag=!freeze] chainTexture 1

execute @a[scores={chainTexture=1..12,chainEnergy=11..},tag=chainsaw,tag=hasForm] ~~~ particle csm:smoke ~~1.5~

execute @a[scores={chainTexture=1,chainEnergy=6..10},tag=chainsaw,tag=hasForm] ~~~ particle csm:smoke ~~1.5~
execute @a[scores={chainTexture=4,chainEnergy=6..10},tag=chainsaw,tag=hasForm] ~~~ particle csm:smoke ~~1.5~
execute @a[scores={chainTexture=7,chainEnergy=6..10},tag=chainsaw,tag=hasForm] ~~~ particle csm:smoke ~~1.5~
execute @a[scores={chainTexture=10,chainEnergy=6..10},tag=chainsaw,tag=hasForm] ~~~ particle csm:smoke ~~1.5~

event entity @a[scores={chainTexture=1,chainEnergy=11..},tag=chainsaw,tag=hasForm] csm:chainsaw0
event entity @a[scores={chainTexture=2,chainEnergy=11..},tag=chainsaw,tag=hasForm] csm:chainsaw1
event entity @a[scores={chainTexture=3,chainEnergy=11..},tag=chainsaw,tag=hasForm] csm:chainsaw0
event entity @a[scores={chainTexture=4,chainEnergy=11..},tag=chainsaw,tag=hasForm] csm:chainsaw1
event entity @a[scores={chainTexture=5,chainEnergy=11..},tag=chainsaw,tag=hasForm] csm:chainsaw0
event entity @a[scores={chainTexture=6,chainEnergy=11..},tag=chainsaw,tag=hasForm] csm:chainsaw1
event entity @a[scores={chainTexture=7,chainEnergy=11..},tag=chainsaw,tag=hasForm] csm:chainsaw0
event entity @a[scores={chainTexture=8,chainEnergy=11..},tag=chainsaw,tag=hasForm] csm:chainsaw1
event entity @a[scores={chainTexture=9,chainEnergy=11..},tag=chainsaw,tag=hasForm] csm:chainsaw0
event entity @a[scores={chainTexture=10,chainEnergy=11..},tag=chainsaw,tag=hasForm] csm:chainsaw1
event entity @a[scores={chainTexture=11,chainEnergy=11..},tag=chainsaw,tag=hasForm] csm:chainsaw0
event entity @a[scores={chainTexture=12,chainEnergy=11..},tag=chainsaw,tag=hasForm] csm:chainsaw1

event entity @a[scores={chainTexture=2,chainEnergy=6..10},tag=chainsaw,tag=hasForm] csm:chainsaw0
event entity @a[scores={chainTexture=4,chainEnergy=6..10},tag=chainsaw,tag=hasForm] csm:chainsaw1
event entity @a[scores={chainTexture=6,chainEnergy=6..10},tag=chainsaw,tag=hasForm] csm:chainsaw0
event entity @a[scores={chainTexture=8,chainEnergy=6..10},tag=chainsaw,tag=hasForm] csm:chainsaw1
event entity @a[scores={chainTexture=10,chainEnergy=6..10},tag=chainsaw,tag=hasForm] csm:chainsaw0
event entity @a[scores={chainTexture=12,chainEnergy=6..10},tag=chainsaw,tag=hasForm] csm:chainsaw1

event entity @a[scores={chainTexture=3,chainEnergy=0..5},tag=chainsaw,tag=hasForm] csm:chainsaw0
event entity @a[scores={chainTexture=6,chainEnergy=0..5},tag=chainsaw,tag=hasForm] csm:chainsaw1
event entity @a[scores={chainTexture=9,chainEnergy=0..5},tag=chainsaw,tag=hasForm] csm:chainsaw0
event entity @a[scores={chainTexture=12,chainEnergy=0..5},tag=chainsaw,tag=hasForm] csm:chainsaw1

execute @a[scores={chainTexture=0..},tag=hasForm,tag=chainsaw,tag=!freeze,tag=!chainSoundsOff] ~~~ playsound tile.piston.out @a ~~~ 0.15
scoreboard players set @a[scores={chainTexture=12..}] chainTexture 0

scoreboard objectives add chainSoundsOff dummy
scoreboard players remove @a[scores={chainSoundsOff=1..},tag=!freeze] chainSoundsOff 1
scoreboard players reset @a[scores={chainSoundsOff=0}] chainSoundsOff

tag @a[scores={chainSoundsOff=2..}] add chainSoundsOff
tag @a[scores={chainSoundsOff=..1}] remove chainSoundsOff

#functions
execute @a[tag=chainsaw] ~~~ function chainsaw_man/chainsaw_man_toggle
execute @a[tag=chainsaw,tag=hasForm,tag=!freeze] ~~~ function chainsaw_man/bleed

#awaken
title @a[tag=chainsaw,tag=!hasForm,tag=!stun,scores={hotbar=8}] actionbar >> §6Awaken §r§f<<
title @a[tag=chainsaw,tag=hasForm,tag=!stun,scores={hotbar=8}] actionbar >> §6Retract Chainsaws §r§f<<


#punch
title @a[tag=chainsaw,tag=hasForm,tag=!stun,scores={hotbar=0}] actionbar >> §6Chainsaw M1 Combo §r§f<<
execute @a[tag=chainsaw,tag=hasForm] ~~~ function chainsaw_man/chainM1
execute @a[scores={punch=2,hotbar=0,chainCD=0},tag=chainsaw,tag=hasForm,tag=!freeze,tag=!stun,tag=!armored] ~~~ function chainsaw_man/chainM1_activate

#grapple
title @a[tag=chainsaw,tag=hasForm,scores={hotbar=5,chainHookCD=0},tag=!stun] actionbar >> §6Chainsaw Grapple §r§f<<
title @a[tag=chainsaw,tag=hasForm,scores={hotbar=5,chainHookCD=1..},tag=!stun] actionbar >> §7§oChainsaw Grapple <<
execute @a[tag=chainsaw,tag=hasForm,tag=!freeze,scores={punch=2,hotbar=5,chainHookCD=0,sneak=0},tag=!stun,tag=!armored] ~~~ scoreboard players add @s chainHook 0
execute @a[tag=chainsaw,tag=hasForm] ~~~ function chainsaw_man/chain_hook

#dash (disabled)
execute @a[tag=chainsaw,tag=hasForm,tag=!freeze,scores={punch=2,hotbar=5,chainDashCD=0,sneak=1},tag=unlocked] ~~~ scoreboard players add @s chainDash 0
execute @a[tag=chainsaw,tag=hasForm,tag=unlocked] ~~~ function chainsaw_man/chain_dash

#kick
title @a[tag=chainsaw,tag=hasForm,scores={hotbar=1,chainKickCD=0},tag=!stun] actionbar >> §6Hidden Chainsaw Kick §r§f<<
title @a[tag=chainsaw,tag=hasForm,scores={hotbar=1,chainKickCD=1..},tag=!stun] actionbar >> §7§oHidden Chainsaw Kick §r§f<<
execute @a[tag=chainsaw,tag=hasForm,tag=!noHS] ~~~ function chainsaw_man/kick
execute @a[tag=chainsaw,tag=hasForm,tag=noHS] ~~~ function chainsaw_man/kick2
execute @a[tag=chainsaw,tag=hasForm,tag=!freeze,scores={hotbar=1,punch=1,chainCD=0,chainKickCD=0},tag=!stun,tag=!armored] ~~~ function chainsaw_man/kick_activate

#double slash
title @a[tag=chainsaw,tag=hasForm,scores={hotbar=2,chainDoubleCD=0},tag=!stun] actionbar >> §6Double Chainsaw Ambush §r§f<<
title @a[tag=chainsaw,tag=hasForm,scores={hotbar=2,chainDoubleCD=1..},tag=!stun] actionbar >> §7§oDouble Chainsaw Ambush §r§f<<
execute @a[tag=chainsaw,tag=hasForm,tag=noHS] ~~~ function chainsaw_man/double_slash
execute @a[tag=chainsaw,tag=hasForm,tag=!noHS] ~~~ function chainsaw_man/double_slash2
execute @a[tag=chainsaw,tag=hasForm,tag=!freeze,scores={hotbar=2,punch=1,chainCD=0,chainDoubleCD=0},tag=!stun,tag=!armored] ~~~ scoreboard players add @s chainDouble 0

#ripper
title @a[tag=chainsaw,tag=hasForm,scores={hotbar=3,chainRipperCD=0},tag=!stun] actionbar >> §6Chainsaw the Ripper §r§f<<
title @a[tag=chainsaw,tag=hasForm,scores={hotbar=3,chainRipperCD=1..},tag=!stun] actionbar >> §7§oChainsaw the Ripper §r§f<<
execute @a[tag=chainsaw,tag=hasForm,tag=noHS] ~~~ function chainsaw_man/ripper1
execute @a[tag=chainsaw,tag=hasForm,tag=!noHS] ~~~ function chainsaw_man/ripper2
execute @a[tag=chainsaw,tag=hasForm,tag=!freeze,scores={hotbar=3,punch=1,chainCD=0,chainRipperCD=0},tag=!stun,tag=!armored] ~~~ scoreboard players add @s chainRipper 0

#cqc
title @a[tag=chainsaw,tag=hasForm,scores={hotbar=4,chainCQCCD=0},tag=!stun] actionbar >> §610-Meter CQC (Close Quarters Chainsaw) §r§f<<
title @a[tag=chainsaw,tag=hasForm,scores={hotbar=4,chainCQCCD=1..},tag=!stun] actionbar >> §7§o10-Meter CQC (Close Quarters Chainsaw) §r§f<<
execute @a[tag=chainsaw,tag=hasForm,tag=noHS] ~~~ function chainsaw_man/cqc1
execute @a[tag=chainsaw,tag=hasForm,tag=!noHS] ~~~ function chainsaw_man/cqc2
execute @a[tag=chainsaw,tag=hasForm,tag=!freeze,scores={hotbar=4,punch=1,chainCD=0,chainCQCCD=0},tag=!stun,tag=!armored] ~~~ scoreboard players add @s chainCQC 0

#revv
execute @a[tag=chainsaw,tag=hasForm,tag=!freeze,tag=!stun] ~~~ function chainsaw_man/energy_bar
execute @a[tag=chainsaw,tag=hasForm,tag=!freeze,scores={hotbar=7,punch=1,chainRev=0},tag=!stun,tag=!armored] ~~~ scoreboard players set @s chainRev 11

#hit stop
scoreboard objectives add hitStop dummy
scoreboard players remove @a[scores={hitStop=1..}] hitStop 1
scoreboard players add @a hitStop 0
execute @a[scores={hitStop=2..}] ~~~ tag @e add freeze
execute @a[scores={hitStop=1}] ~~~ tag @e remove freeze

#the contract
execute @a[hasitem={item=csm:pochita},tag=!chainsaw] ~~~ spawnpoint @s ~~~

scoreboard objectives add chainDia dummy
scoreboard players add @a[scores={chainDia=0..}] chainDia 1

clear @a[scores={chainDia=0..}] csm:pochita
effect @a[scores={chainDia=0..140}] blindness 2 0 true
scoreboard players set @a[scores={chainDia=0..182}] iframes 2
tellraw @a[scores={chainDia=40}] {"rawtext":[{"text":"§6I've loved listening to you talk about your dreams."}]}
tellraw @a[scores={chainDia=80}] {"rawtext":[{"text":"§6This is a contract."}]}
tellraw @a[scores={chainDia=120}] {"rawtext":[{"text":"§6I'll give you my heart."}]}
tellraw @a[scores={chainDia=160}] {"rawtext":[{"text":"§6In exchange, let me see your dreams come true."}]}

execute @a[scores={chainDia=178}] ~~~ function chainsaw_designation

scoreboard players add @a[scores={chainDia=180}] chainTransTime 0
scoreboard players add @a[scores={chainDia=180}] chainOnTime 0
tag @a[scores={chainDia=180}] add hasForm

scoreboard players reset @a[scores={chainDia=182..}] chainDia

#pochita
execute @a[scores={use=1},hasitem={item=csm:pochita,location=slot.weapon.mainhand}] ~~~ function chainsaw_man/pochita

scoreboard objectives add chainSus dummy
scoreboard players add @a[scores={chainSus=0..}] chainSus 1
tag @s[scores={chainSus=0..10}] add pochitaCD
tag @s[scores={chainSus=20..}] remove pochitaCD
scoreboard players reset @a[scores={chainSus=25..}] chainSus
execute @a[scores={chainSus=0..5}] ~~~ playsound tile.piston.out @a ~~~

#real dodge
execute @a[scores={sneak=1,hotbar=0..6,chainDodgeCD=0},tag=chainsaw,tag=hasForm,tag=!freeze,tag=!stun] ~~~ scoreboard players add @s chainDodge 0
execute @a[tag=chainsaw,tag=hasForm] ~~~ function chainsaw_man/dodge